diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/phy-entity.h ns-3.44/src/wifi/model/phy-entity.h
--- ns-3.43/src/wifi/model/phy-entity.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/phy-entity.h	2025-03-09 16:55:49.795372700 -0700
@@ -754,45 +763,45 @@
      * Obtain a random value from the WifiPhy's generator.
      * Wrapper used by child classes.
      *
-     * \return a uniform random value
+     * @return a uniform random value
      */
     double GetRandomValue() const;
     /**
      * Obtain the SNR and PER of the PPDU field from the WifiPhy's InterferenceHelper class.
      * Wrapper used by child classes.
      *
-     * \param field the PPDU field
-     * \param event the event holding incoming PPDU's information
-     * \return the SNR and PER
+     * @param field the PPDU field
+     * @param event the event holding incoming PPDU's information
+     * @return the SNR and PER
      */
     SnrPer GetPhyHeaderSnrPer(WifiPpduField field, Ptr<Event> event) const;
     /**
      * Obtain the received power for a given band.
      * Wrapper used by child classes.
      *
-     * \param event the event holding incoming PPDU's information
-     * \return the received power for the event over a given band
+     * @param event the event holding incoming PPDU's information
+     * @return the received power for the event over a given band
      */
     Watt_u GetRxPowerForPpdu(Ptr<Event> event) const;
     /**
      * Get the pointer to the current event (stored in WifiPhy).
      * Wrapper used by child classes.
      *
-     * \return the pointer to the current event
+     * @return the pointer to the current event
      */
     Ptr<const Event> GetCurrentEvent() const;
     /**
      * Get the map of current preamble events (stored in WifiPhy).
      * Wrapper used by child classes.
      *
-     * \return the reference to the map of current preamble events
+     * @return the reference to the map of current preamble events
      */
     const std::map<std::pair<uint64_t, WifiPreamble>, Ptr<Event>>& GetCurrentPreambleEvents() const;
     /**
      * Add an entry to the map of current preamble events (stored in WifiPhy).
      * Wrapper used by child classes.
      *
-     * \param event the event holding incoming PPDU's information
+     * @param event the event holding incoming PPDU's information
      */
     void AddPreambleEvent(Ptr<Event> event);
 
@@ -800,12 +809,12 @@
      * Create an event using WifiPhy's InterferenceHelper class.
      * Wrapper used by child classes.
      *
-     * \param ppdu the PPDU
-     * \param duration the PPDU duration
-     * \param rxPower received power per band (W)
-     * \param isStartHePortionRxing flag whether the event corresponds to the start of the OFDMA
+     * @param ppdu the PPDU
+     * @param duration the PPDU duration
+     * @param rxPower received power per band (W)
+     * @param isStartHePortionRxing flag whether the event corresponds to the start of the OFDMA
      * payload reception (only used for UL-OFDMA)
-     * \return the created event
+     * @return the created event
      */
     Ptr<Event> CreateInterferenceEvent(Ptr<const WifiPpdu> ppdu,
                                        Time duration,
@@ -820,9 +829,9 @@
      * updated accordingly. Otherwise, a new interference event is created and PPDU is dropped by
      * the PHY.
      *
-     * \param event the event of the ongoing reception
-     * \param ppdu the newly received PPDU (UL MU or non-HT duplicate)
-     * \param rxPower the received power (W) per band of the newly received PPDU
+     * @param event the event of the ongoing reception
+     * @param ppdu the newly received PPDU (UL MU or non-HT duplicate)
+     * @param rxPower the received power (W) per band of the newly received PPDU
      */
     virtual void HandleRxPpduWithSameContent(Ptr<Event> event,
                                              Ptr<const WifiPpdu> ppdu,
@@ -832,14 +841,14 @@
      * Notify WifiPhy's InterferenceHelper of the end of the reception,
      * clear maps and end of MPDU event, and eventually reset WifiPhy.
      *
-     * \param reset whether to reset WifiPhy
+     * @param reset whether to reset WifiPhy
      */
     void NotifyInterferenceRxEndAndClear(bool reset);
 
     /**
-     * \param txPower power to spread across the bands
-     * \param ppdu the PPDU that will be transmitted
-     * \return Pointer to SpectrumValue
+     * @param txPower power to spread across the bands
+     * @param ppdu the PPDU that will be transmitted
+     * @return Pointer to SpectrumValue
      *
      * This is a helper function to create the right TX PSD corresponding
      * to the amendment of this PHY.
@@ -850,8 +859,8 @@
     /**
      * Fire the trace indicating that the PHY is starting to receive the payload of a PPDU.
      *
-     * \param txVector the TXVECTOR used to transmit the PPDU
-     * \param payloadDuration the TX duration of the PPDU payload
+     * @param txVector the TXVECTOR used to transmit the PPDU
+     * @param payloadDuration the TX duration of the PPDU payload
      */
     void NotifyPayloadBegin(const WifiTxVector& txVector, const Time& payloadDuration);
 
@@ -862,9 +871,9 @@
      * channel width). Otherwise, this call is equivalent to GetBand with
      * <i>bandIndex</i> equal to zero.
      *
-     * \param bandWidth the width of the band to be returned
+     * @param bandWidth the width of the band to be returned
      *
-     * \return the info corresponding to the band
+     * @return the info corresponding to the band
      */
     WifiSpectrumBandInfo GetPrimaryBand(MHz_u bandWidth) const;
     /**
@@ -872,47 +881,47 @@
      * the secondary channel of the given bandwidth (which must be a multiple of 20 MHz
      * and not exceed the operating channel width).
      *
-     * \param bandWidth the width of the band to be returned
+     * @param bandWidth the width of the band to be returned
      *
-     * \return the info corresponding to the band
+     * @return the info corresponding to the band
      */
     WifiSpectrumBandInfo GetSecondaryBand(MHz_u bandWidth) const;
 
     /**
      * Return the channel width used to measure the RSSI.
      *
-     * \param ppdu the PPDU that is being received
-     * \return the channel width used for RSSI measurement
+     * @param ppdu the PPDU that is being received
+     * @return the channel width used for RSSI measurement
      */
     virtual MHz_u GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const = 0;
 
     /**
      * Return the channel width used in the reception spectrum model.
      *
-     * \param txVector the TXVECTOR of the PPDU that is being received
-     * \return the channel width used for RxSpectrumModel
+     * @param txVector the TXVECTOR of the PPDU that is being received
+     * @return the channel width used for RxSpectrumModel
      */
     virtual MHz_u GetRxChannelWidth(const WifiTxVector& txVector) const;
 
     /**
      * Return the delay until CCA busy is ended for a given sensitivity threshold and a given band.
      *
-     * \param threshold the CCA sensitivity threshold
-     * \param band identify the requested band
-     * \return the delay until CCA busy is ended
+     * @param threshold the CCA sensitivity threshold
+     * @param band identify the requested band
+     * @return the delay until CCA busy is ended
      */
     Time GetDelayUntilCcaEnd(dBm_u threshold, const WifiSpectrumBandInfo& band);
 
     /**
-     * \param currentChannelWidth channel width of the current transmission
-     * \return the width of the guard band
+     * @param currentChannelWidth channel width of the current transmission
+     * @return the width of the guard band
      *
      * Wrapper method used by child classes for PSD generation.
      * Note that this method is necessary for testing UL OFDMA.
      */
     MHz_u GetGuardBandwidth(MHz_u currentChannelWidth) const;
     /**
-     * \return a tuple containing the minimum rejection for the inner band,
+     * @return a tuple containing the minimum rejection for the inner band,
      *                            the minimum rejection for the outer band, and
      *                            the maximum rejection for the outer band
      *                            for the transmit spectrum mask.
@@ -930,8 +939,8 @@
      * Get CCA end time and its corresponding channel list type when a new signal has been received
      * by the PHY.
      *
-     * \param ppdu the incoming PPDU or nullptr for any signal
-     * \return CCA end time and its corresponding channel list type when a new signal has been
+     * @param ppdu the incoming PPDU or nullptr for any signal
+     * @return CCA end time and its corresponding channel list type when a new signal has been
      * received by the PHY, or std::nullopt if all channel list types are IDLE.
      */
     virtual CcaIndication GetCcaIndication(const Ptr<const WifiPpdu> ppdu);
@@ -943,8 +952,9 @@
     std::list<WifiMode> m_modeList; //!< the list of supported modes
 
     std::vector<EventId> m_endPreambleDetectionEvents; //!< the end of preamble detection events
-    std::vector<EventId> m_endOfMpduEvents;   //!< the end of MPDU events (only used for A-MPDUs)
-    std::vector<EventId> m_endOfMacHdrEvents; //!< the end of MAC header events
+    std::vector<EventId> m_endOfMpduEvents; //!< the end of MPDU events (only used for A-MPDUs)
+    std::map<uint16_t, std::vector<EventId>>
+        m_endOfMacHdrEvents; //!< STA_ID-indexed map of the RX end of MAC header events
 
     std::vector<EventId>
         m_endRxPayloadEvents; //!< the end of receive events (only one unless UL MU reception)
@@ -965,19 +975,19 @@
 };                                   // class PhyEntity
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param action the action to perform in case of failure
- * \returns a reference to the stream
+ * @param os the stream
+ * @param action the action to perform in case of failure
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const PhyEntity::PhyRxFailureAction& action);
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param status the status of the reception of a PPDU field
- * \returns a reference to the stream
+ * @param os the stream
+ * @param status the status of the reception of a PPDU field
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const PhyEntity::PhyFieldRxStatus& status);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/preamble-detection-model.h ns-3.44/src/wifi/model/preamble-detection-model.h
--- ns-3.43/src/wifi/model/preamble-detection-model.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/preamble-detection-model.h	2025-03-09 16:55:49.795372700 -0700
@@ -17,16 +17,16 @@
 {
 
 /**
- * \ingroup wifi
- * \brief the interface for Wifi's preamble detection models
+ * @ingroup wifi
+ * @brief the interface for Wifi's preamble detection models
  *
  */
 class PreambleDetectionModel : public Object
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -34,11 +34,11 @@
      * A pure virtual method that must be implemented in the subclass.
      * This method returns whether the preamble detection was successful.
      *
-     * \param rssi the RSSI of the received signal.
-     * \param snr the SNR of the received signal in linear scale.
-     * \param channelWidth the channel width of the received signal.
+     * @param rssi the RSSI of the received signal.
+     * @param snr the SNR of the received signal in linear scale.
+     * @param channelWidth the channel width of the received signal.
      *
-     * \return true if the preamble has been detected,
+     * @return true if the preamble has been detected,
      *         false otherwise
      */
     virtual bool IsPreambleDetected(dBm_u rssi, double snr, MHz_u channelWidth) const = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/qos-frame-exchange-manager.cc ns-3.44/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.43/src/wifi/model/qos-frame-exchange-manager.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/qos-frame-exchange-manager.cc	2025-03-09 16:55:49.795372700 -0700
@@ -74,7 +74,6 @@
 {
     NS_LOG_FUNCTION(this);
     NS_ASSERT(m_edca);
-    NS_ASSERT(m_edca->GetTxopLimit(m_linkId).IsStrictlyPositive());
 
     WifiMacHeader cfEnd;
     cfEnd.SetType(WIFI_MAC_CTL_END);
@@ -91,10 +90,10 @@
 
     auto mpdu = Create<WifiMpdu>(Create<Packet>(), cfEnd);
     auto txDuration =
-        m_phy->CalculateTxDuration(mpdu->GetSize(), cfEndTxVector, m_phy->GetPhyBand());
+        WifiPhy::CalculateTxDuration(mpdu->GetSize(), cfEndTxVector, m_phy->GetPhyBand());
 
-    // Send the CF-End frame if the remaining duration is long enough to transmit this frame
-    if (m_edca->GetRemainingTxop(m_linkId) > txDuration)
+    // Send the CF-End frame if the remaining TXNAV is long enough to transmit this frame
+    if (m_txNav > Simulator::Now() + txDuration)
     {
         NS_LOG_DEBUG("Send CF-End frame");
         ForwardMpduDown(mpdu, cfEndTxVector);
@@ -111,9 +110,9 @@
 }
 
 void
-QosFrameExchangeManager::PifsRecovery()
+QosFrameExchangeManager::PifsRecovery(bool forceCurrentCw)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << forceCurrentCw);
     NS_ASSERT(m_edca);
     NS_ASSERT(m_edca->GetTxopStartTime(m_linkId).has_value());
 
@@ -122,9 +121,14 @@
         m_allowedWidth,
         m_channelAccessManager->GetLargestIdlePrimaryChannel(m_phy->GetPifs(), Simulator::Now()));
 
-    if (m_allowedWidth == 0)
+    if (m_allowedWidth == MHz_u{0})
     {
+        // PIFS recovery failed, TXOP is terminated
         NotifyChannelReleased(m_edca);
+        if (!forceCurrentCw)
+        {
+            m_edca->UpdateFailedCw(m_linkId);
+        }
         m_edca = nullptr;
     }
     else
@@ -484,9 +488,10 @@
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(m_edca->GetRemainingTxop(m_linkId) -
-                        m_phy->CalculateTxDuration(size, txParams.m_txVector, m_phy->GetPhyBand()),
-                    *txParams.m_acknowledgment->acknowledgmentTime);
+    return std::max(
+        m_edca->GetRemainingTxop(m_linkId) -
+            WifiPhy::CalculateTxDuration(size, txParams.m_txVector, m_phy->GetPhyBand()),
+        *txParams.m_acknowledgment->acknowledgmentTime);
 }
 
 Time
@@ -511,9 +516,10 @@
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(m_edca->GetRemainingTxop(m_linkId) -
-                        m_phy->CalculateTxDuration(GetRtsSize(), rtsTxVector, m_phy->GetPhyBand()),
-                    Seconds(0));
+    return std::max(
+        m_edca->GetRemainingTxop(m_linkId) -
+            WifiPhy::CalculateTxDuration(GetRtsSize(), rtsTxVector, m_phy->GetPhyBand()),
+        Seconds(0));
 }
 
 Time
@@ -538,9 +544,10 @@
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(m_edca->GetRemainingTxop(m_linkId) -
-                        m_phy->CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()),
-                    Seconds(0));
+    return std::max(
+        m_edca->GetRemainingTxop(m_linkId) -
+            WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()),
+        Seconds(0));
 }
 
 void
@@ -583,6 +590,11 @@
 
         // we are continuing a TXOP, hence the txopDuration parameter is unused
         Simulator::Schedule(m_phy->GetSifs(), fp, this, m_edca, Seconds(0));
+
+        if (m_protectedIfResponded)
+        {
+            m_protectedStas.merge(m_sentFrameTo);
+        }
     }
     else
     {
@@ -590,17 +602,18 @@
         m_edca = nullptr;
     }
     m_initialFrame = false;
+    m_sentFrameTo.clear();
 }
 
 void
-QosFrameExchangeManager::TransmissionFailed()
+QosFrameExchangeManager::TransmissionFailed(bool forceCurrentCw)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << forceCurrentCw);
 
     // TODO This will be removed once no Txop is installed on a QoS station
     if (!m_edca)
     {
-        FrameExchangeManager::TransmissionFailed();
+        FrameExchangeManager::TransmissionFailed(forceCurrentCw);
         return;
     }
 
@@ -609,6 +622,10 @@
         // The backoff procedure shall be invoked by an EDCAF when the transmission
         // of an MPDU in the initial PPDU of a TXOP fails (Sec. 10.22.2.2 of 802.11-2016)
         NS_LOG_DEBUG("TX of the initial frame of a TXOP failed: terminate TXOP");
+        if (!forceCurrentCw)
+        {
+            m_edca->UpdateFailedCw(m_linkId);
+        }
         NotifyChannelReleased(m_edca);
         m_edca = nullptr;
     }
@@ -633,8 +650,10 @@
             // the medium is idle in a PIFS
             NS_LOG_DEBUG("TX of a non-initial frame of a TXOP failed: perform PIFS recovery");
             NS_ASSERT(!m_pifsRecoveryEvent.IsPending());
-            m_pifsRecoveryEvent =
-                Simulator::Schedule(m_phy->GetPifs(), &QosFrameExchangeManager::PifsRecovery, this);
+            m_pifsRecoveryEvent = Simulator::Schedule(m_phy->GetPifs(),
+                                                      &QosFrameExchangeManager::PifsRecovery,
+                                                      this,
+                                                      forceCurrentCw);
         }
         else
         {
@@ -643,11 +662,19 @@
             // requests channel access if needed,
             NS_LOG_DEBUG("TX of a non-initial frame of a TXOP failed: invoke backoff");
             m_edca->Txop::NotifyChannelReleased(m_linkId);
+            // CW and QSRC shall be updated in this case (see Section 10.23.2.2 of 802.11-2020)
+            if (!forceCurrentCw)
+            {
+                m_edca->UpdateFailedCw(m_linkId);
+            }
             m_edcaBackingOff = m_edca;
             m_edca = nullptr;
         }
     }
     m_initialFrame = false;
+    m_sentFrameTo.clear();
+    // reset TXNAV because transmission failed
+    m_txNav = Simulator::Now();
 }
 
 void
@@ -667,10 +694,9 @@
                 NS_LOG_DEBUG("Station " << hdr.GetAddr2() << " reported a buffer status of "
                                         << +hdr.GetQosQueueSize()
                                         << " for tid=" << +hdr.GetQosTid());
-                StaticCast<ApWifiMac>(m_mac)->SetBufferStatus(
-                    hdr.GetQosTid(),
-                    mpdu->GetOriginal()->GetHeader().GetAddr2(),
-                    hdr.GetQosQueueSize());
+                m_apMac->SetBufferStatus(hdr.GetQosTid(),
+                                         mpdu->GetOriginal()->GetHeader().GetAddr2(),
+                                         hdr.GetQosQueueSize());
             }
         }
     }
@@ -702,6 +728,12 @@
 }
 
 std::optional<Mac48Address>
+QosFrameExchangeManager::GetTxopHolder() const
+{
+    return m_txopHolder;
+}
+
+std::optional<Mac48Address>
 QosFrameExchangeManager::FindTxopHolder(const WifiMacHeader& hdr, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << hdr << txVector);
@@ -760,6 +792,8 @@
                                      const WifiTxVector& txVector,
                                      bool inAmpdu)
 {
+    NS_LOG_FUNCTION(this << *mpdu << rxSignalInfo << txVector << inAmpdu);
+
     // The received MPDU is either broadcast or addressed to this station
     NS_ASSERT(mpdu->GetHeader().GetAddr1().IsGroup() || mpdu->GetHeader().GetAddr1() == m_self);
 
@@ -778,12 +812,12 @@
         if (hdr.GetAddr2() == m_txopHolder || VirtualCsMediumIdle())
         {
             NS_LOG_DEBUG("Received RTS from=" << hdr.GetAddr2() << ", schedule CTS");
-            Simulator::Schedule(m_phy->GetSifs(),
-                                &QosFrameExchangeManager::SendCtsAfterRts,
-                                this,
-                                hdr,
-                                txVector.GetMode(),
-                                rxSnr);
+            m_sendCtsEvent = Simulator::Schedule(m_phy->GetSifs(),
+                                                 &QosFrameExchangeManager::SendCtsAfterRts,
+                                                 this,
+                                                 hdr,
+                                                 txVector.GetMode(),
+                                                 rxSnr);
         }
         else
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/qos-frame-exchange-manager.h ns-3.44/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.43/src/wifi/model/qos-frame-exchange-manager.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/qos-frame-exchange-manager.h	2025-03-09 16:55:49.795372700 -0700
@@ -17,7 +17,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * QosFrameExchangeManager handles the frame exchange sequences
  * for QoS stations.
@@ -27,8 +27,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     QosFrameExchangeManager();
@@ -44,10 +44,10 @@
      * The protection and acknowledgment methods held by the given TX parameters are
      * only updated if the given MPDU can be added.
      *
-     * \param mpdu the MPDU to add to the frame being built
-     * \param txParams the TX parameters describing the frame being built
-     * \param availableTime the time limit on the frame exchange sequence
-     * \return true if the given MPDU can be added to the frame being built
+     * @param mpdu the MPDU to add to the frame being built
+     * @param txParams the TX parameters describing the frame being built
+     * @param availableTime the time limit on the frame exchange sequence
+     * @return true if the given MPDU can be added to the frame being built
      */
     bool TryAddMpdu(Ptr<const WifiMpdu> mpdu, WifiTxParameters& txParams, Time availableTime) const;
 
@@ -56,10 +56,10 @@
      * by the given TX parameters) without violating the given constraint on the
      * PPDU transmission duration.
      *
-     * \param mpdu the MPDU to add to the frame being built
-     * \param txParams the TX parameters describing the frame being built
-     * \param ppduDurationLimit the time limit on the PPDU transmission duration
-     * \return true if the given MPDU can be added to the frame being built
+     * @param mpdu the MPDU to add to the frame being built
+     * @param txParams the TX parameters describing the frame being built
+     * @param ppduDurationLimit the time limit on the PPDU transmission duration
+     * @return true if the given MPDU can be added to the frame being built
      */
     virtual bool IsWithinLimitsIfAddMpdu(Ptr<const WifiMpdu> mpdu,
                                          const WifiTxParameters& txParams,
@@ -72,11 +72,11 @@
      * <i>ppduPayloadSize</i>. Also check that the PSDU size does not exceed the
      * max PSDU size for the modulation class being used.
      *
-     * \param ppduPayloadSize the new PSDU size
-     * \param receiver the MAC address of the receiver of the PSDU
-     * \param txParams the TX parameters describing the frame being built
-     * \param ppduDurationLimit the limit on the PPDU duration
-     * \return true if the constraints on the PPDU duration limit and the maximum PSDU size are met
+     * @param ppduPayloadSize the new PSDU size
+     * @param receiver the MAC address of the receiver of the PSDU
+     * @param txParams the TX parameters describing the frame being built
+     * @param ppduDurationLimit the limit on the PPDU duration
+     * @return true if the constraints on the PPDU duration limit and the maximum PSDU size are met
      */
     virtual bool IsWithinSizeAndTimeLimits(uint32_t ppduPayloadSize,
                                            Mac48Address receiver,
@@ -88,11 +88,16 @@
      * This is required by 11be MLDs to support translation of MAC addresses. For single
      * link devices, the given MPDU is simply returned.
      *
-     * \param mpdu the given MPDU
-     * \return the alias of the given MPDU for transmission on this link
+     * @param mpdu the given MPDU
+     * @return the alias of the given MPDU for transmission on this link
      */
     virtual Ptr<WifiMpdu> CreateAliasIfNeeded(Ptr<WifiMpdu> mpdu) const;
 
+    /**
+     * @return the TXOP holder (if any)
+     */
+    std::optional<Mac48Address> GetTxopHolder() const;
+
   protected:
     void DoDispose() override;
 
@@ -115,17 +120,17 @@
                                 Time txDuration,
                                 Time response) const override;
     void TransmissionSucceeded() override;
-    void TransmissionFailed() override;
+    void TransmissionFailed(bool forceCurrentCw = false) override;
     void ForwardMpduDown(Ptr<WifiMpdu> mpdu, WifiTxVector& txVector) override;
 
     /**
      * Request the FrameExchangeManager to start a frame exchange sequence.
      *
-     * \param edca the EDCA that gained channel access
-     * \param txopDuration the duration of a TXOP. This value is only used when a
+     * @param edca the EDCA that gained channel access
+     * @param txopDuration the duration of a TXOP. This value is only used when a
      *                     new TXOP is started (and hence the TXOP limit for the
      *                     given EDCAF is non-zero)
-     * \return true if a frame exchange sequence was started, false otherwise
+     * @return true if a frame exchange sequence was started, false otherwise
      */
     virtual bool StartTransmission(Ptr<QosTxop> edca, Time txopDuration);
 
@@ -134,13 +139,13 @@
      * as needed) that fits within the given <i>availableTime</i> (if different than
      * Time::Min()).
      *
-     * \param edca the EDCAF which has been granted the opportunity to transmit
-     * \param availableTime the amount of time allowed for the frame exchange. Pass
+     * @param edca the EDCAF which has been granted the opportunity to transmit
+     * @param availableTime the amount of time allowed for the frame exchange. Pass
      *                      Time::Min() in case the TXOP limit is null
-     * \param initialFrame true if the frame being transmitted is the initial frame
+     * @param initialFrame true if the frame being transmitted is the initial frame
      *                     of the TXOP. This is used to determine whether the TXOP
      *                     limit can be exceeded
-     * \return true if a frame exchange is started, false otherwise
+     * @return true if a frame exchange is started, false otherwise
      */
     virtual bool StartFrameExchange(Ptr<QosTxop> edca, Time availableTime, bool initialFrame);
 
@@ -148,23 +153,26 @@
      * Perform a PIFS recovery as a response to transmission failure within a TXOP.
      * If the carrier sense indicates that the medium is idle, continue the TXOP.
      * Otherwise, release the channel.
+     *
+     * @param forceCurrentCw whether to force the contention window to stay equal to the current
+     *                       value if PIFs recovery fails (normally, contention window is updated)
      */
-    void PifsRecovery();
+    void PifsRecovery(bool forceCurrentCw);
 
     /**
      * Send a CF-End frame to indicate the completion of the TXOP, provided that
      * the remaining duration is long enough to transmit this frame.
      *
-     * \return true if a CF-End frame was sent, false otherwise
+     * @return true if a CF-End frame was sent, false otherwise
      */
     virtual bool SendCfEndIfNeeded();
 
     /**
      * Determine the holder of the TXOP, if possible, based on the received frame
      *
-     * \param hdr the MAC header of an MPDU included in the received PSDU
-     * \param txVector TX vector of the received PSDU
-     * \return the holder of the TXOP, if one was found
+     * @param hdr the MAC header of an MPDU included in the received PSDU
+     * @param txVector TX vector of the received PSDU
+     * @return the holder of the TXOP, if one was found
      */
     virtual std::optional<Mac48Address> FindTxopHolder(const WifiMacHeader& hdr,
                                                        const WifiTxVector& txVector);
@@ -183,8 +191,8 @@
     /**
      * Set the TXOP holder, if needed, based on the received frame
      *
-     * \param psdu the received PSDU
-     * \param txVector TX vector of the received PSDU
+     * @param psdu the received PSDU
+     * @param txVector TX vector of the received PSDU
      */
     void SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
 
